<?php

namespace Modules\User\Policies;

use Illuminate\Auth\Access\HandlesAuthorization;
use Modules\User\Entities\Heir;

class HeirPolicy
{
    use HandlesAuthorization;

    public function viewAny($user): bool
    {
        return true;
    }

    public function view($user, ?Heir $heir = null): bool
    {
        return $heir === null || $heir->user_id === $user->id;
    }

    public function create($user): bool
    {
        return true;
    }

    public function update($user, ?Heir $heir = null): bool
    {
        return $heir === null || $heir->user_id === $user->id;
    }

    public function deleteAny($user): bool
    {
        return true;
    }

    public function delete($user, ?Heir $heir = null): bool
    {
        return $heir === null || $heir->user_id === $user->id;
    }
}
